/* vim:set ts=2 sw=2 sts=2 ai si nu et ft=javascript ff=unix:

  Last Change: 12-May-2014 10:34:31.
  Author: Technical team.
  Copyright: (C)Anchor Group K.K.

  URL: http://www.anchor-gr.jp/labo.html
  EMAIL: info@anchor-gr.jp

  Filename: smartscroll.js
  smartscroll-arrow.png, smartscroll.css, smartscroll-run.js

  Example:
    see README.
    eccube only.

 ---------------------------------------------------------*/
var smartScrollVersion = "1.6.0a";

$.extend($.easing, {
  // original: easeOutQuint
  smart: function (x, t, b, c, d) {
    return c*((t=t/d-1)*t*t*t*t + 1) + b;
  }
});

function smartScroll(opts)
{
  function _wheel_event()
  {
    function __cancel(e)
    {
      if (__isscroll) {
        if (params.wheel_action == WA_FORCE) {
          if (_isie()) {
            event.cancelBubble = true;
            event.returnValue = false;
          } else {
            //e.stopPropagation();
            e.preventDefault();
          }
        } else {
          $(__body).stop();
          __isscroll = false;
        }
      }
    }

    if (params.wheel_action != WA_NONE) {
      if (window.addEventListener) {
        window.addEventListener('mousewheel', function(e){__cancel(e);}, false);
        window.addEventListener('DOMMouseScroll', function(e){__cancel(e);}, false);
      } else {
        document.attachEvent('onmousewheel', function(e){__cancel(e);});
      }
    }
  }

  function _scroll(ta, hash)
  {
    //if (!__isscroll && $(window).scrollTop() > 10) {
    if (!__isscroll) {

      __isscroll = true;

      var wait = typeof(hash)=="string" ? params.wait : 200;
      var offset = ta.position().top == 0 ? 0 : params.offset;
      if (ta.get(0).tagName.toLowerCase() == "html") {
        var el_top = ta.get(0).offsetTop;
      } else {
        var el_top = ta.offset().top;
      }
      var el_left = ta.position().left;
      var el_offset = el_top;

      if (_isie6()) {
        if (ta.position().top > 0) {
          el_offset += $('body').scrollTop();
        }
      }

      if ($(document).height()-ta.position().top < $(window).height()) {
        el_offset = el_offset - ($(window).height() - ($(document).height() - ta.position().top));
      }

      var ___scroll = function(){
        $(__body).animate(
          //{scrollTop: ta.offset().top}, params.speed, params.easing, function(){
          {scrollTop: el_offset+offset}, params.speed, params.easing, function(){
              if (typeof(hash)=="string" && (_iswebkit() || _isie())) {
                location.hash = hash;
                //e.preventDefault();
              }

              if (params.overlay) {
                //$('#'+params.cursor_id+'_ov').fadeOut("slow", function(e) {
                $('#'+params.cursor_id+'_ov').fadeOut(200, function(e) {
                  $(this).css({width: 0, height: 0});
                });
              }

              __isscroll = false;

              if (params.cursor && params.cursor !== "") {
                if (el_offset > 10) {
                  $("#"+params.cursor_id).css({top: el_top, left: el_left-24}).fadeIn(1000);

                  if (params.cursor_line) {
                    if (params.cursor_line == "after") {
                      ta.after($('#' + params.cursor_id+'_line'));
                    } else {
                      $('#' + params.cursor_id+'_line').insertBefore(ta);
                    }

                    $("#"+params.cursor_id+"_line").fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500);
                  }

                  setTimeout(function() {
                    $("#"+params.cursor_id).fadeOut(2000);
                    if (params.cursor_line) {
                      $("#"+params.cursor_id+"_line").fadeOut(2000);
                    }
                  }, 3000);
                }
              }
           }
        );
      }

      if (params.overlay) {
        $('#'+params.cursor_id+'_ov').css({
          position: "absolute",
          top: 0,
          left: 0,
          "background-color": "black",
          overflow: "hidden",
          width: "100%", 
          height: $(document).height()
        //}).fadeTo(100, 0.7, function(e) {
        }).fadeTo(300, (params.overlay ? 0.7 : 0), function(e) {
          setTimeout(function() {___scroll(); }, wait);
        });
      } else {
        setTimeout(function() {___scroll(); }, wait);
      }
    }
  }

  function _isie6()
  {
    return navigator.userAgent.match(/msie 6\.0/i);
  }

  function _isie()
  {
    return navigator.userAgent.match(/msie/i);
  }

  function _iswebkit()
  {
    var chrome = /Chrome/.test(navigator.userAgent) && /Google Inc/.test(navigator.vendor);
    var safari = /Safari/.test(navigator.userAgent) && /Apple Computer/.test(navigator.vendor);
    return (chrome || safari);
  }

  function _overlay()
  {
    if (params.overlay) {
      $('body').append('<div style="display:none;position:absolute;width:1px;height:1px;z-index:100;" id="' + params.cursor_id + '_ov"></div>');

      $("#"+params.cursor_id+"_ov").click(function(e) {
        $(__body).stop();
        //$('#'+params.cursor_id+'_ov').fadeOut("slow", function() {
        $('#'+params.cursor_id+'_ov').fadeOut(500, function() {
          $(this).css({width: 0, height: 0});
          __isscroll = false;
        });

      });
    }
  }

  function _cursor()
  {
    if (params.cursor && params.cursor !== "") {
      var ua = navigator.userAgent.toLowerCase();
      var cursor = new Image();

      cursor.src = params.cursor;
      $('body').append('<div style="display:none;position:absolute;" id="' + params.cursor_id + '"><img></div>');
      $("#"+params.cursor_id+" img").attr("src", cursor.src).css({width: cursor.width, height: cursor.height});
      $('body').append('<div id="' + params.cursor_id+'_line" style="display:none;margin:3px;margin-top:-10px; height: 1px; border-top: 4px dashed red;"></div>');

      if (/ie [78]\./.test(ua)) {
        $("#__ss_cursor img").css({
          filter: 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' + cursor.src + '", sizingMethod="scale");'
        });
      }
    }
  }

  function _scroll_button()
  {
    if (params.button && /object/i.test(typeof(params.button))) {
      var bt = $('#' + params.button.id);

      //bt.hide();

      $(window).scroll(function () {
        var top = $(this).scrollTop();

        if (top > params.button.show_pos) {
          bt.fadeIn();
        } else {
          bt.fadeOut();
        }

        var pos = ($(document).height() - (window.innerHeight ? window.innerHeight : $(window).height()));

        if (top >= (pos)) {
          bt.css("bottom", (top - pos + params.button.bottom_offset));
        } else {
          if (top <= (pos)) bt.css("bottom", params.button.bottom_offset);
        }

      });
    }
  }

  function _startup()
  {
    var startup = location.href.split("#")[1];

    if (startup && startup != "") {
      var startup = "#" + startup;
      var t = $(startup);

      if (t.length == 1) {
        var jump = true;
        
        if (enable.length == 0) {
          if ($.inArray(startup, disable)>-1) jump = false;
        } else {
          jump = ($.inArray(startup, enable)>-1) ? true : false;
        }

        if (jump) {
          scrollTo(0,0);
          if (_iswebkit() || _isie()) location.hash = "";
          setTimeout(function(){ 
            _scroll(t, startup.split("#")[1]); 
          }, params.wait);
        }
      }
    }
  }

  var WA_NONE = "none";
  var WA_FORCE = "force";
  var WA_CANCEL = "cancel";
  
  var DEFAULT_PARAMS = {
    startup: true,
    speed: 1500,
    wait: 500,
    easing: "smart",
    wheel_action: WA_FORCE,
    cursor: false,
    cursor_id: "__ss_cursor",
    cursor_line: "before",
    overlay: false,
    offset: 0,
    disableds: Array(),
    enableds: Array()
  };

  var DEFAULT_BUTTON_PARAMS = {
    id: "scroll_button",
    show_pos: 100,
    bottom_offset: 20
  };
  
  var __isscroll = false;
  var __body = "html";

  var params = $.extend(DEFAULT_PARAMS, opts);

  if (typeof(params.button) === "undefined") {
    params.button = $.extend(DEFAULT_BUTTON_PARAMS, params.button);
  }

  var hash = Array();
  var doc = location.href.split("#")[0];
  var enable = params.enableds;
  var disable = params.disableds;
  var cursor;

  if (_iswebkit() || _isie6()) __body = "body";

  if (enable && enable.length > 0) {
    for (var i = 0; i<enable.length; i++) {
      hash.push('a[href$=' + enable[i] + ']');
    }
  } else {
    hash.push('a[href*=#]');
  }

  $(hash.join(",")).click(function(e) {
    var href= $(this).attr("href");
    // href="#h301" ハッシュのみ記述の場合不具合

    if (!href.match(/^\#/)) {
      var href= $(this).prop("href");
      var uri = href.split("#");
      if (uri[0] == doc) {
        href = "#" + uri[1];
      } else {
        return true;
      }
    }

    if ($.inArray(href, disable)>-1) return true;

    var t = $((href == "#" || href == "") ? 'html' : href);
    _scroll(t);

    //if (_isie()) window.event.returnValue = false;
    return false;
  });

  _wheel_event();
  _cursor();
  _overlay();
  _scroll_button();

  if (params.startup) _startup();
}


